// CycmNative.cpp

#include "stdafx.h"
#include "common.h"

class NativeTestModule : public ATL::CAtlDllModuleT<NativeTestModule>, boost::noncopyable { };

NativeTestModule _AtlModule;

BOOL APIENTRY DllMain(HANDLE, DWORD dwReason, LPVOID lpReserved)
{
	return _AtlModule.DllMain(dwReason, lpReserved); 
}

STDAPI DllCanUnloadNow()
{
	return _AtlModule.DllCanUnloadNow();
}

STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
	return _AtlModule.DllGetClassObject(rclsid, riid, ppv);
}

ATL::CComPtr<IDebug> g_Debug;
 
HRESULT DebugWriteLineF(LPCWSTR format, ...)
{
	WCHAR buffer[1024];
	std::va_list arg;
	va_start(arg, format);
	int size = wvsprintf(buffer, format, arg);
	if (size > 0)
	{
		ATL::CComBSTR str(size, buffer);
		return g_Debug->WriteLine(str);
	}
	else
	{
		return ATL::AtlHresultFromLastError();
	}
}
